var MenuItem = require("menu-item");
var Menu = require("menu");

var ContextMenu = function(tray) {
  this.tray = tray;
  this.items = [];
};

ContextMenu.prototype = {
  addItem: function(item) {
    this.items.push(item);
  },

  removeItem: function(item) {
    var index = this.items.indexOf(item);
    if (index !== -1) {
      this.items.splice(index, 1);
    }
  },

  refresh: function() {
    var menu = new Menu();
    for (var i=0; i<this.items.length; i++) {
      menu.append(this.items[i].item);
    }
    this.tray.setContextMenu(menu);
  }
};

var ContextMenuItem = function(options) {
  this.item = new MenuItem(options);
};

ContextMenuItem.prototype = {
  setLabel: function(label) {
    this.item.label = label;
  },

  enable: function() {
    this.item.enabled = true;
  },

  disable: function() {
    this.item.enabled = false;
  },

  addTo: function(contextMenu) {
    this.contextMenu = contextMenu;
    this.contextMenu.addItem(this);
    return this;
  },

  removeFrom: function(contextMenu) {
    this.contextMenu = contextMenu;
    this.contextMenu.removeItem(this);
    return this;
  }
};

exports.ContextMenu = ContextMenu;
exports.ContextMenuItem = ContextMenuItem;