/* jshint esversion: 6, node: true */
'use strict';

const BrowserWindow  = require('browser-window');

module.exports = function protoDialog(viewPath, options, callback) {

  var windowIsOpened = false;
  function windowIsClosed() {
    windowIsOpened = false;
  }

  return function() {
    if (windowIsOpened) return;
    windowIsOpened = true;

    var instance = new BrowserWindow(options);
    instance.on('close', windowIsClosed);

    var promise = callback.apply(instance, arguments) || Promise.resolve();

    return promise.then(function() {
      instance.loadURL(`file://${ __dirname }/views/${ viewPath }.html`);
      if (process.env.DEBUG) instance.openDevTools({ detach: true });
    });
  };
};
