/* jshint esversion: 6, node: true, unused: true */
'use strict';

function Queriable(collection) {
  this.collection = collection;
}
(function(fn) {
  function strictlyMatches(conditions) {
    var keys = Object.keys(conditions);

    return function(item) {
      function keyIsEqual(key) { return item[key] === conditions[key]; }
      return keys.every(keyIsEqual);
    };
  }
  // function matches(conditions) {
  //   var keys = Object.keys(conditions);
  //
  //   return function(item) {
  //     function keyIsEqual(key) { return item[key] == conditions[key]; }
  //     return keys.every(keyIsEqual);
  //   }
  // }
  var slice = Array.prototype.slice;
  function hasProperties(properties) {
    properties = slice.call(properties);

    return function(i) {
      return properties.every(function(p) { return i.hasOwnProperty(p); });
    };
  }

  fn.where = function(conditions) {
    var matcher = strictlyMatches(conditions);
    return new this.constructor(this.collection.filter(matcher));
  };
  // fn.whereIn = function(conditions) {
  //   var matcher = ;
  //   return new this.constructor(this.collection.filter(matcher));
  // };
  fn.findBy = function(conditions) {
    var matcher = strictlyMatches(conditions);
    return this.collection.find(matcher);
  };
  fn.withProperties = function() {
    var matcher = hasProperties(arguments);
    return new this.constructor(this.collection.filter(matcher));
  };
  fn.withProperty = fn.withProperties;

  fn.mapTo = function(property) {
    function mapper(item) { return item[property]; }
    return new this.constructor(this.collection.map(mapper));
  };

  fn.each = function(callback) {
    this.collection.forEach(callback);
    return this;
  };

  fn.set = function(properties) {
    var keys = Object.keys(properties);
    function setter(item) {
      keys.forEach(function(key) { item[key] = properties[key]; });
    }

    return this.each(setter);
  };
}(Queriable.prototype));

module.exports = Queriable;
